library global;

import 'package:flutter/material.dart';

export 'package:android_path_provider/android_path_provider.dart';
export 'package:device_info_plus/device_info_plus.dart';
export 'package:flutter_downloader/flutter_downloader.dart';
export 'package:flutter_svg/flutter_svg.dart';
export 'package:fluttertoast/fluttertoast.dart';
export 'package:http/http.dart';
export 'package:intl/intl.dart';
export 'package:path_provider/path_provider.dart';
export 'package:permission_handler/permission_handler.dart';

export './src/GColors.dart';
export './src/GDateFormats.dart';
export './src/GHttpReqs.dart';
export './src/GPageTransition.dart';
export './src/GRefreshingWidget.dart';
export './src/GRegExpMatchers.dart';
export './src/GTextInputFormatters.dart';
export './src/GTexts.dart';
export './src/GUtils.dart';
export './src/GValidators.dart';
export './src/GValues.dart';
export './src/dialogs/GCustomAlertDialog.dart';
export './src/dialogs/GHeaderAndActionDialog.dart';
export './src/dialogs/GSearchableTextFieldDialog.dart';

class Global {
  static bool _initialized = false;
  static late Color _themeColor;
  static late TextStyle _textStyle;
  static late GlobalKey<NavigatorState> _navigatorKey;

  /// Initializes the plugin. This must be called before any other method.
  static initialize({
    required Color themeColor,
    required TextStyle textStyle,
    required GlobalKey<NavigatorState> navigatorKey,
  }) {
    assert(
      !_initialized,
      'Plugin \'global\' has already been initialized',
    );
    _themeColor = themeColor;
    _textStyle = textStyle;
    _navigatorKey = navigatorKey;
    _initialized = true;
  }

  static GlobalKey<NavigatorState> get navigatorKey => _navigatorKey;

  static TextStyle get textStyle => _textStyle;

  static Color get themeColor => _themeColor;
}
