import 'package:flutter/material.dart';
import 'package:global/global.dart';

import 'GHeaderAndActionDialog.dart';

class GCustomAlertDialog extends GHeaderAndActionDialog {
  final String title, content;
  final Function? action;

  const GCustomAlertDialog({
    required this.title,
    required this.content,
    this.action,
    super.key,
  });

  @override
  GHeaderAndActionDialogState<GCustomAlertDialog> createState() =>
      _CustomAlertDialogState();
}

class _CustomAlertDialogState
    extends GHeaderAndActionDialogState<GCustomAlertDialog> {
  late GCustomAlertDialog _alertDialog;

  @override
  void initState() {
    super.initState();
    _alertDialog = widget as GCustomAlertDialog;
  }

  @override
  Widget contentBuilder(BuildContext context) => Padding(
        padding: const EdgeInsets.only(left: 5),
        child: Column(
          mainAxisSize: MainAxisSize.min,
          crossAxisAlignment: CrossAxisAlignment.stretch,
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            GUtils.getText(title: _alertDialog.content, fontSize: 15),
          ],
        ),
      );

  @override
  String getHeaderText() => _alertDialog.title;

  @override
  List<Map<String, Function>> getButtonsDetails() => _alertDialog.action == null
      ? []
      : [
          {
            GTexts.yes: () {
              Navigator.pop(context);
              if (_alertDialog.action != null) {
                _alertDialog.action!();
              }
            }
          }
        ];
}
